import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.awt.Image.*;
import javax.imageio.*;
import java.awt.Font.*;



public class KlamathWebCam extends JFrame
{

///---> Variables:
URL imageLocation = null;
URLConnection connection = null;
Image mainJPEG = null;
Image mainImg = null;
JPanel mainPanel = null;
JButton refreshButton = null;
JButton stopButton = null;
MainCanvas imgCanvas = null;
Long imgTime = null;
Boolean keepGoing = true;
Boolean keepRunning = true;
StartUpdatingThread updatingThread = null;
JLabel titleLabel = null;
Font titleLabelFont = new Font("Times New Roman", Font.BOLD, 25);

    
    
    KlamathWebCam(String title) 
    {
        super(title);
        
        //---->
        getnewPicture();
        //<----
        
        mainPanel = new JPanel();
        refreshButton = new JButton("Refresh");
        stopButton = new JButton("Stop");
        imgCanvas = new MainCanvas();
        titleLabel = new JLabel("Klamath.net WebCam");
        
        imgCanvas.setSize(new Dimension(640,480));
        
        titleLabel.setFont(titleLabelFont);
        
        refreshButton.addActionListener(new refreshAction());
        stopButton.addActionListener(new stopAction());
        
        getRootPane().setDefaultButton(refreshButton);
        
        mainPanel.add(titleLabel);
        mainPanel.add(imgCanvas);
        mainPanel.add(refreshButton);
        mainPanel.add(stopButton);
        
        getContentPane().add(mainPanel);
        setSize(700,620);
        setVisible(true);
        
        
        
        

    }
    
    
    

    public static void main(String[] args) {
        
        KlamathWebCam app = new KlamathWebCam("Klamath.net WebCam");
        app.startMainThread();
       }
       
    public void startMainThread() {
     updatingThread = new StartUpdatingThread();
     updatingThread.start();
        
    }
        
/////////////////////////////////////////////////////////////////////////////////////////////      
       public void getnewPicture() {
           
           try {
              
            imageLocation = new URL("http", "www.klamath.net", "/main2.jpg"); 
            connection = imageLocation.openConnection();
            imgTime = connection.getDate();
            mainImg = ImageIO.read(imageLocation);
        }

        catch (MalformedURLException ex) { System.out.println("URL did not form properly");}

        catch (IOException ex) { ex.printStackTrace(); }

        catch (java.security.AccessControlException ex) { ex.printStackTrace(); }
 
       }
////////////////////////////////////////////////////////////////////////////////////////////////


 class MainCanvas extends Canvas {

    MainCanvas() { System.out.println("MainCanvas was created!!"); }
    
    public void paint(Graphics g) {
        
        g.drawImage(mainImg,0,0,this);
        
        
    }
}//<--End of MainCanvas

     class refreshAction implements ActionListener {
        
        public void actionPerformed (ActionEvent e) {
            getnewPicture();
            imgCanvas.repaint();
            System.out.println(keepGoing + " <----------------KEEPGOING!");

        }
        
    }//<--End of refreshAction
    
    class stopAction implements ActionListener {
        
        public void actionPerformed(ActionEvent e) {
            String buttonText = stopButton.getText();
            if (buttonText == "Start") { 
                    stopButton.setText("Stop"); 
                    keepGoing = true;  
                    System.out.println(keepGoing); 
                    StartUpdatingThread newUpdatingThread = new StartUpdatingThread(); 
                    newUpdatingThread.start();
                }
            if (buttonText == "Stop") { stopButton.setText("Start"); keepGoing = false; }
            //add code to change button to start
            
            
            
            
        }
    }
    
    class StartUpdatingThread extends Thread {
      public void run() {
          System.out.println("THREAD STARTING TO RUN!");
        while (keepRunning == true) {
                
            if (keepGoing == true) {
            Long nextGoAbout = imgTime + 5000;//five seconds more
            
            if ( ( (nextGoAbout - connection.getDate()) < 10000) ) {
                getnewPicture();
                imgCanvas.repaint();
            }
        }
        }     
    

    

    }//<--end of StartUpdatingThread()
    
}
}//<--End of KlamathWebCam

            





   

